uninstall.sh 11 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://blog.linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RadHat 5+ Debian 6+ and Ubuntu 12+
  6. #
  7. # Project home page:
  8. # http://oneinstack.com
  9. # https://github.com/lj2007331/oneinstack
  10. export PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RadHat 5+ Debian 6+ and Ubuntu 12+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit http://oneinstack.com #
  17. #######################################################################
  18. "
  19. . ./options.conf
  20. . ./include/color.sh
  21. . ./include/get_char.sh
  22. . ./include/check_dir.sh
  23. # Check if user is root
  24. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  25. Usage(){
  26. printf "
  27. Usage: $0 [ ${CMSG}all${CEND} | ${CMSG}web${CEND} | ${CMSG}db${CEND} | ${CMSG}php${CEND} | ${CMSG}hhvm${CEND} | ${CMSG}pureftpd${CEND} | ${CMSG}redis${CEND} | ${CMSG}memcached${CEND} ]
  28. ${CMSG}all${CEND} --->Uninstall All
  29. ${CMSG}web${CEND} --->Uninstall Nginx/Tengine/Apache/Tomcat
  30. ${CMSG}db${CEND} --->Uninstall MySQL/MariaDB/Percona
  31. ${CMSG}php${CEND} --->Uninstall PHP
  32. ${CMSG}hhvm${CEND} --->Uninstall HHVM
  33. ${CMSG}pureftpd${CEND} --->Uninstall PureFtpd
  34. ${CMSG}redis${CEND} --->Uninstall Redis
  35. ${CMSG}memcached${CEND} --->Uninstall Memcached
  36. "
  37. }
  38. Uninstall_status() {
  39. while :; do echo
  40. read -p "Do you want to uninstall? [y/n]: " uninstall_yn
  41. echo
  42. if [[ ! $uninstall_yn =~ ^[y,n]$ ]];then
  43. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  44. else
  45. break
  46. fi
  47. done
  48. }
  49. Print_Warn() {
  50. echo
  51. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  52. }
  53. Print_web() {
  54. [ -d "$nginx_install_dir" ] && echo "$nginx_install_dir"
  55. [ -d "$tengine_install_dir" ] && echo "$tengine_install_dir"
  56. [ -d "$openresty_install_dir" ] && echo "$openresty_install_dir"
  57. [ -e "/etc/init.d/nginx" ] && echo '/etc/init.d/nginx'
  58. [ -e "/etc/logrotate.d/nginx" ] && echo '/etc/logrotate.d/nginx'
  59. [ -d "$apache_install_dir" ] && echo "$apache_install_dir"
  60. [ -e "/etc/init.d/httpd" ] && echo "/etc/init.d/httpd"
  61. [ -e "/etc/logrotate.d/apache" ] && echo "/etc/logrotate.d/apache"
  62. [ -d "$tomcat_install_dir" ] && echo "$tomcat_install_dir"
  63. [ -e "/etc/init.d/tomcat" ] && echo "/etc/init.d/tomcat"
  64. [ -e "/etc/logrotate.d/tomcat" ] && echo "/etc/logrotate.d/tomcat"
  65. [ -d "/usr/java" ] && echo '/usr/java'
  66. }
  67. Uninstall_Web() {
  68. [ -d "$nginx_install_dir" ] && { killall nginx > /dev/null 2>&1; rm -rf $nginx_install_dir /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@$nginx_install_dir/sbin:@@" /etc/profile; }
  69. [ -d "$tengine_install_dir" ] && { killall nginx > /dev/null 2>&1; rm -rf $tengine_install_dir /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@$tengine_install_dir/sbin:@@" /etc/profile; }
  70. [ -d "$openresty_install_dir" ] && { killall nginx > /dev/null 2>&1; rm -rf $openresty_install_dir /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@$openresty_install_dir/nginx/sbin:@@" /etc/profile; }
  71. [ -d "$apache_install_dir" ] && { service httpd stop > /dev/null 2>&1; rm -rf $apache_install_dir /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@$apache_install_dir/bin:@@" /etc/profile; }
  72. [ -d "$tomcat_install_dir" ] && { killall java > /dev/null 2>&1; rm -rf $tomcat_install_dir /etc/init.d/tomcat; /etc/logrotate.d/tomcat; }
  73. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  74. [ -e "$wwwroot_dir" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  75. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  76. sed -i 's@^local_bankup_yn=.*@local_bankup_yn=y@' ./options.conf
  77. sed -i 's@^remote_bankup_yn=.*@remote_bankup_yn=n@' ./options.conf
  78. echo "${CMSG}Web uninstall completed${CEND}"
  79. }
  80. Print_DB() {
  81. [ -e "$db_install_dir" ] && echo "$db_install_dir"
  82. [ -e "/etc/init.d/mysqld" ] && echo "/etc/init.d/mysqld"
  83. [ -e "/etc/my.cnf" ] && echo "/etc/my.cnf"
  84. }
  85. Uninstall_DB() {
  86. [ -e "$db_install_dir" ] && { service mysqld stop > /dev/null 2>&1; rm -rf $db_install_dir /etc/init.d/mysqld /etc/my.cnf /etc/ld.so.conf.d/{mysql,mariadb,percona}*.conf; }
  87. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  88. [ -e "$db_data_dir" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  89. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  90. sed -i "s@$db_install_dir/bin:@@" /etc/profile
  91. echo "${CMSG}DB uninstall completed${CEND}"
  92. }
  93. Print_PHP() {
  94. [ -e "$php_install_dir" ] && echo "$php_install_dir"
  95. [ -e "/etc/init.d/php-fpm" ] && echo "/etc/init.d/php-fpm"
  96. [ -e "/usr/local/imagemagick" ] && echo "/usr/local/imagemagick"
  97. [ -e "/usr/local/graphicsmagick" ] && echo '/usr/local/graphicsmagick'
  98. }
  99. Uninstall_PHP() {
  100. [ -e "$php_install_dir/bin/phpize" -a -e "$php_install_dir/etc/php-fpm.conf" ] && { service php-fpm stop > /dev/null 2>&1; rm -rf $php_install_dir /etc/init.d/php-fpm; }
  101. [ -e "$php_install_dir/bin/phpize" -a ! -e "$php_install_dir/etc/php-fpm.conf" ] && rm -rf $php_install_dir
  102. [ -e "/usr/local/imagemagick" ] && rm -rf /usr/local/imagemagick
  103. [ -e "/usr/local/graphicsmagick" ] && rm -rf /usr/local/graphicsmagick
  104. sed -i "s@$php_install_dir/bin:@@" /etc/profile
  105. echo "${CMSG}PHP uninstall completed${CEND}"
  106. }
  107. Print_HHVM() {
  108. [ -e "/usr/bin/hhvm" ] && echo "/usr/bin/hhvm"
  109. [ -e "/etc/hhvm" ] && echo "/etc/hhvm"
  110. [ -e "/var/log/hhvm" ] && echo "/var/log/hhvm"
  111. [ -e "/etc/supervisord.conf" ] && echo "/etc/supervisord.conf"
  112. [ -e "/etc/init.d/supervisord" ] && echo "/etc/init.d/supervisord"
  113. }
  114. Uninstall_HHVM() {
  115. [ -e "/etc/init.d/supervisord" ] && { service supervisord stop > /dev/null 2>&1; rm -rf /etc/supervisord.conf /etc/init.d/supervisord; }
  116. [ -e "/usr/bin/hhvm" ] && { rpm -e hhvm; rm -rf /etc/hhvm /var/log/hhvm /usr/bin/hhvm; }
  117. echo "${CMSG}HHVM uninstall completed${CEND}"
  118. }
  119. Print_PureFtpd() {
  120. [ -e "$pureftpd_install_dir" ] && echo "$pureftpd_install_dir"
  121. [ -e "/etc/init.d/pureftpd" ] && echo "/etc/init.d/pureftpd"
  122. }
  123. Uninstall_PureFtpd() {
  124. [ -e "$pureftpd_install_dir" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf $pureftpd_install_dir /etc/init.d/pureftpd; }
  125. echo "${CMSG}Pureftpd uninstall completed${CEND}"
  126. }
  127. Print_Redis() {
  128. [ -e "$redis_install_dir" ] && echo "$redis_install_dir"
  129. [ -e "/etc/init.d/redis-server" ] && echo "/etc/init.d/redis-server"
  130. }
  131. Uninstall_Redis() {
  132. [ -e "$redis_install_dir" ] && { service redis-server stop > /dev/null 2>&1; rm -rf $redis_install_dir /etc/init.d/redis-server /usr/local/bin/redis-*; }
  133. [ -e "$php_install_dir/etc/php.d/ext-redis.ini" ] && rm -rf $php_install_dir/etc/php.d/ext-redis.ini
  134. echo "${CMSG}Redis uninstall completed${CEND}"
  135. }
  136. Print_Memcached() {
  137. [ -e "$memcached_install_dir" ] && echo "$memcached_install_dir"
  138. [ -e "/etc/init.d/memcached" ] && echo "/etc/init.d/memcached"
  139. [ -e "/usr/bin/memcached" ] && echo "/usr/bin/memcached"
  140. }
  141. Uninstall_Memcached() {
  142. [ -e "$memcached_install_dir" ] && { service memcached stop > /dev/null 2>&1; rm -rf $memcached_install_dir /etc/init.d/memcached /usr/bin/memcached; }
  143. [ -e "$php_install_dir/etc/php.d/ext-memcache.ini" ] && rm -rf $php_install_dir/etc/php.d/ext-memcache.ini
  144. [ -e "$php_install_dir/etc/php.d/ext-memcached.ini" ] && rm -rf $php_install_dir/etc/php.d/ext-memcached.ini
  145. echo "${CMSG}Memcached uninstall completed${CEND}"
  146. }
  147. Menu(){
  148. while :; do
  149. printf "
  150. What Are You Doing?
  151. \t${CMSG}0${CEND}. Uninstall All
  152. \t${CMSG}1${CEND}. Uninstall Nginx/Tengine/Apache/Tomcat
  153. \t${CMSG}2${CEND}. Uninstall MySQL/MariaDB/Percona
  154. \t${CMSG}3${CEND}. Uninstall PHP
  155. \t${CMSG}4${CEND}. Uninstall HHVM
  156. \t${CMSG}5${CEND}. Uninstall PureFtpd
  157. \t${CMSG}6${CEND}. Uninstall Redis
  158. \t${CMSG}7${CEND}. Uninstall Memcached
  159. \t${CMSG}q${CEND}. Exit
  160. "
  161. echo
  162. read -p "Please input the correct option: " Number
  163. if [[ ! $Number =~ ^[0-7,q]$ ]];then
  164. echo "${CWARNING}input error! Please only input 0,1,2,3,4,5,6,7 and q${CEND}"
  165. else
  166. case "$Number" in
  167. 0)
  168. Print_Warn
  169. Print_web
  170. Print_DB
  171. Print_PHP
  172. Print_HHVM
  173. Print_PureFtpd
  174. Print_Redis
  175. Print_Memcached
  176. Uninstall_status
  177. if [ "$uninstall_yn" == 'y' ];then
  178. Uninstall_Web
  179. Uninstall_DB
  180. Uninstall_PHP
  181. Uninstall_HHVM
  182. Uninstall_PureFtpd
  183. Uninstall_Redis
  184. Uninstall_Memcached
  185. else
  186. exit
  187. fi
  188. ;;
  189. 1)
  190. Print_Warn
  191. Print_web
  192. Uninstall_status
  193. [ "$uninstall_yn" == 'y' ] && Uninstall_Web || exit
  194. ;;
  195. 2)
  196. Print_Warn
  197. Print_DB
  198. Uninstall_status
  199. [ "$uninstall_yn" == 'y' ] && Uninstall_DB || exit
  200. ;;
  201. 3)
  202. Print_PHP
  203. Uninstall_status
  204. [ "$uninstall_yn" == 'y' ] && Uninstall_PHP || exit
  205. ;;
  206. 4)
  207. Print_HHVM
  208. Uninstall_status
  209. [ "$uninstall_yn" == 'y' ] && Uninstall_HHVM || exit
  210. ;;
  211. 5)
  212. Print_PureFtpd
  213. Uninstall_status
  214. [ "$uninstall_yn" == 'y' ] && Uninstall_PureFtpd || exit
  215. ;;
  216. 6)
  217. Print_Redis
  218. Uninstall_status
  219. [ "$uninstall_yn" == 'y' ] && Uninstall_Redis || exit
  220. ;;
  221. 7)
  222. Print_Memcached
  223. Uninstall_status
  224. [ "$uninstall_yn" == 'y' ] && Uninstall_Memcached || exit
  225. ;;
  226. q)
  227. exit
  228. ;;
  229. esac
  230. fi
  231. done
  232. }
  233. if [ $# == 0 ];then
  234. Menu
  235. elif [ $# == 1 ];then
  236. case $1 in
  237. all)
  238. Print_Warn
  239. Print_web
  240. Print_DB
  241. Print_PHP
  242. Print_HHVM
  243. Print_PureFtpd
  244. Print_Redis
  245. Print_Memcached
  246. Uninstall_status
  247. if [ "$uninstall_yn" == 'y' ];then
  248. Uninstall_Web
  249. Uninstall_DB
  250. Uninstall_PHP
  251. Uninstall_HHVM
  252. Uninstall_PureFtpd
  253. Uninstall_Redis
  254. Uninstall_Memcached
  255. else
  256. exit
  257. fi
  258. ;;
  259. web)
  260. Print_Warn
  261. Print_web
  262. Uninstall_status
  263. [ "$uninstall_yn" == 'y' ] && Uninstall_Web || exit
  264. ;;
  265. db)
  266. Print_Warn
  267. Print_DB
  268. Uninstall_status
  269. [ "$uninstall_yn" == 'y' ] && Uninstall_DB || exit
  270. ;;
  271. php)
  272. Print_PHP
  273. Uninstall_status
  274. [ "$uninstall_yn" == 'y' ] && Uninstall_PHP || exit
  275. ;;
  276. hhvm)
  277. Print_HHVM
  278. Uninstall_status
  279. [ "$uninstall_yn" == 'y' ] && Uninstall_HHVM || exit
  280. ;;
  281. pureftpd)
  282. Print_PureFtpd
  283. Uninstall_status
  284. [ "$uninstall_yn" == 'y' ] && Uninstall_PureFtpd || exit
  285. ;;
  286. redis)
  287. Print_Redis
  288. Uninstall_status
  289. [ "$uninstall_yn" == 'y' ] && Uninstall_Redis || exit
  290. ;;
  291. memcached)
  292. Print_Memcached
  293. Uninstall_status
  294. [ "$uninstall_yn" == 'y' ] && Uninstall_Memcached || exit
  295. ;;
  296. *)
  297. Usage
  298. ;;
  299. esac
  300. else
  301. Usage
  302. fi